Index: /trunk/src/VBox/Additions/WINNT/VBoxCredProv/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxCredProv/Makefile.kmk	(revision 25882)
+++ /trunk/src/VBox/Additions/WINNT/VBoxCredProv/Makefile.kmk	(revision 25883)
@@ -7,6 +7,15 @@
 # Copyright (C) 2009 Sun Microsystems, Inc.
 #
-# Sun Microsystems, Inc. confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.cpp	(revision 25882)
+++ /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.cpp	(revision 25883)
@@ -7,6 +7,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.h
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.h	(revision 25882)
+++ /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredPoller.h	(revision 25883)
@@ -7,6 +7,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredProv.rc
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredProv.rc	(revision 25882)
+++ /trunk/src/VBox/Additions/WINNT/VBoxCredProv/VBoxCredProv.rc	(revision 25883)
@@ -2,6 +2,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxCredProv/guid.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxCredProv/guid.cpp	(revision 25882)
+++ /trunk/src/VBox/Additions/WINNT/VBoxCredProv/guid.cpp	(revision 25883)
@@ -5,6 +5,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Additions/freebsd/drm/Makefile
===================================================================
--- /trunk/src/VBox/Additions/freebsd/drm/Makefile	(revision 25882)
+++ /trunk/src/VBox/Additions/freebsd/drm/Makefile	(revision 25883)
@@ -16,13 +16,4 @@
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
 # Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
 # Clara, CA 95054 USA or visit http://www.sun.com if you need
Index: /trunk/src/VBox/Additions/freebsd/drm/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/freebsd/drm/Makefile.kmk	(revision 25882)
+++ /trunk/src/VBox/Additions/freebsd/drm/Makefile.kmk	(revision 25883)
@@ -7,6 +7,15 @@
 # Copyright (C) 2009 Sun Microsystems, Inc.
 #
-# Sun Microsystems, Inc. confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c
===================================================================
--- /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c	(revision 25882)
+++ /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c	(revision 25883)
@@ -6,6 +6,15 @@
  * Copyright (C) 2008 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 /*
Index: /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vfs.c
===================================================================
--- /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vfs.c	(revision 25882)
+++ /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vfs.c	(revision 25883)
@@ -6,6 +6,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vnode.c
===================================================================
--- /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vnode.c	(revision 25882)
+++ /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_vnode.c	(revision 25883)
@@ -6,6 +6,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 